# delete-file.tcl,v 1.6.2.1 2000/02/03 09:50:35 ron Exp
# /file-storage/delete-file.tcl
#
# created by aure@arsdigita.com, July 1999
#
# modified by randyg@arsidgita.com, January, 2000 to use the general permissions
# system
#
# this page makes sure that a user wants to delete a file or a folder.  
# If a folder is deleted, all of the children are also deleted.
#


set_the_usual_form_variables 

# file_id, object_type, return_url, maybe group_id
 
set user_id [ad_verify_and_get_user_id]
ad_maybe_redirect_for_registration

set title "Delete $object_type"
set db [ns_db gethandle ]

set exception_text ""
set exception_count 0

if {(![info exists file_id])||([empty_string_p $file_id])} {
    incr exception_count
    append exception_text "<li>No file was specified"
}

set version_id [database_to_tcl_string $db "select version_id from fs_versions_latest where file_id = $file_id"]

if {![info exists group_id]} {
    set group_id ""
}

if {! [fs_check_edit_p $db $user_id $version_id $group_id]} {
    incr exception_count
    append exception_text "<li>You do not own this file $user_id $version_id $group_id [ad_g_write_p $db [ad_g_permissions_id $db $version_id FS_VERSIONS] $user_id]"
}

if {(![info exists object_type])||([empty_string_p $object_type])} {
    incr exception_count 
    incr exception_text "<li>This page may only be accessed from the edit page"
}

## return errors
if { $exception_count> 0 } {
    ad_return_complaint $exception_count $exception_text
    return 0
}

set file_title [database_to_tcl_string $db "select file_title from fs_files where file_id=$file_id"]


if { [info exists group_id] && ![empty_string_p $group_id]} {
    set navbar [ad_context_bar_ws [list "index.tcl" [ad_parameter SystemName fs]]  $title]
} else {
    set navbar [ad_context_bar_ws [list "index.tcl" [ad_parameter SystemName fs]] $title]
    set return_url index.tcl
}

set html "[ad_header $title ]

<h2> $title </h2>

$navbar

<hr>

<blockquote>
"

set number_of_children 0

# if this is a folder - get the number of childern
if {$object_type=="Folder"} {
#     set sql_child_count "Select count(*)-1
#                          from   fs_files
#                          connect by prior file_id = parent_id
#                          start with file_id=$file_id "
    set sql_child_count "
      select count(*) - 1
      from   fs_files
      where fs_node_is_child($file_id,file_id) = 't'"
    set number_of_children [database_to_tcl_string $db $sql_child_count]
    append html "This folder has $number_of_children sub-folders/files. <p>"
}


if {$number_of_children > 0} {
    append html "
    Are you sure you want to delete $file_title and all of it sub-folders/files?
    "
} else {
    append html "
     Are you sure you want to delete $file_title?
    "
}

append html "
     <form action=$return_url method=post>
      <input type=submit value=\"No, Don't Delete\" >
    </form>
    <form action=delete-file-2.tcl method=post >
     <input type=submit value=\"Yes, Delete!\" >
     [export_form_vars group_id file_id]
    </form>

</blockquote>
[ad_footer [fs_system_owner]]
"

ns_db releasehandle $db 

ns_return 200 text/html $html






